#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "SpiceUsr.h"

#define  STRLEN 100


main(int argc, char *argv[]) {


  SpiceDouble             et;
  SpiceDouble             start_et;
  SpiceDouble             end_et;
  SpiceChar               utc[STRLEN];
  
  SpiceDouble             SC_pos_J2k[3];
  SpiceDouble             earth_pos_J2k[3];
  SpiceDouble             itokawa_pos_J2k[3];
  SpiceDouble             SC_pos_sefixed[3];
  SpiceDouble             earth_pos_sefixed[3];
  SpiceDouble             itokawa_pos_sefixed[3];
  SpiceDouble             lt;
  
  SpiceDouble             SC_earth_dist, SC_itokawa_dist;
  
  
  //ϻ֤
  SpiceChar   start_time[STRLEN]="2003-05-09T00:00:00";
  SpiceChar   end_time[STRLEN]="2005-09-12T00:00:00";
  
  if (argc < 2) {
    printf("Usage: %s kernel ...\n",argv[0]);
    exit(-1);
  }
  //Ѥkernelɤ߹ߡti2utcȤή㤦ɤǤ褤
  while (argc > 1) {
    furnsh_c (argv[1]);
    fprintf(stderr,"%s is loaded.\n",argv[1]);
    --argc;
    ++argv;
  }
  
  //ŪˤETѤΤǡUTCγϻ֤ETѴ
  str2et_c ( start_time, &start_et );
  str2et_c ( end_time, &end_et );
  

  printf ( "#SC_pos_J2k_X\tY\tZ\tearth_pos_J2k_X\tY\tZ\titokawa_pos_J2k_X\tY\tZ\tSC_pos_sefixed_X\tY\tZ\tearth_pos_sefixed_X\tY\tZ\titokawa_pos_sefixed_X\tY\tZ\n");

  //ϻ֤end_timeޤǤߤǷ׻
  for(et=start_et;et< end_et;et=et+3600*24){
    
    //etUTCѴɽ
    et2utc_c ( et, "ISOC", 0, STRLEN, utc );
    printf("%s\t",utc);
    
    spkpos_c ( "MUSES-C", et,   "J2000",  "NONE", "SUN", SC_pos_J2k,  &lt);
    spkpos_c ( "EARTH", et,   "J2000",  "NONE", "SUN", earth_pos_J2k,  &lt);
    spkpos_c ( "ITOKAWA", et,   "J2000",  "NONE", "SUN", itokawa_pos_J2k,  &lt);
    
    SC_earth_dist = vdist_c(SC_pos_J2k, earth_pos_J2k);
    SC_itokawa_dist = vdist_c(SC_pos_J2k, itokawa_pos_J2k);
    
    spkpos_c ( "MUSES-C", et,   "SUN_EARTH_FIXED",  "NONE", "SUN", SC_pos_sefixed,  &lt);
    spkpos_c ( "EARTH", et,   "SUN_EARTH_FIXED",  "NONE", "SUN", earth_pos_sefixed,  &lt);
    spkpos_c ( "ITOKAWA", et,   "SUN_EARTH_FIXED",  "NONE", "SUN", itokawa_pos_sefixed,  &lt);
    
    printf ( "%9.4f\t%9.4f\t%9.4f\t%9.4f\t%9.4f\t%9.4f\t%9.4f\t%9.4f\t%9.4f\t%9.4f\t%9.4f\t%9.4f\t%9.4f\t%9.4f\t%9.4f\t%9.4f\t%9.4f\t%9.4f\t%9.4f\t%9.4f\n",
            SC_pos_J2k[0], SC_pos_J2k[1], SC_pos_J2k[2],
            earth_pos_J2k[0], earth_pos_J2k[1], earth_pos_J2k[2],
            itokawa_pos_J2k[0], itokawa_pos_J2k[1], itokawa_pos_J2k[2],
            SC_pos_sefixed[0], SC_pos_sefixed[1], SC_pos_sefixed[2],
            earth_pos_sefixed[0], earth_pos_sefixed[1], earth_pos_sefixed[2],
            itokawa_pos_sefixed[0], itokawa_pos_sefixed[1], itokawa_pos_sefixed[2],
            SC_earth_dist, SC_itokawa_dist
            );
  }
}
